<?php
/*
Plugin Name: PHPBB Single Sign On
Version: 0.6.2
Plugin URI: http://www.onigoetz.ch/plugins/wordpress-phpbb-plugin/
Description: Connecte un site wordpress à PHPBB
Author: Stéphane Goetz
Author URI: http://www.onigoetz.ch
*/



define('FROM_WP',TRUE);

//Installation
register_activation_hook( __FILE__, 'connect_phpbb_install');
function connect_phpbb_install(){
    $default_options = array(
        'path' => 'forum/',
    );
    add_option('connect_phpbb_options', $default_options);
}

//Options page
add_action('admin_menu', 'connect_phpbb_options_page');
function connect_phpbb_options_page() {
	add_options_page('PHP BB', 'PHP BB Options', 10, 'phpbb-single-sign-on/options.php');
}

include (dirname(__FILE__).'/common-functions.php');
include (dirname(__FILE__).'/module.phpbb.php');
include (dirname(__FILE__).'/module.wp.php');


global $op_credentials;

// AUTHENTICATE
add_action('wp_authenticate_user','wpbb_login',10,2);
function wpbb_login(&$userdata,$password){
	
    if(file_exists(ABSPATH.'/'.PHPBBPATH.'config.php')){ // check to see if phpBB exists
        if(defined('IN_PHPBB')){
			return $userdata; // return if we're already in phpBB (to avoid a loop)
	}

          // FIX start, RamonFincken.com WebsiteFreelancers.nl
          // Fix for phpbb3 login attempts. If too many failed logins, phpbb demands you enter a visual code
          // So include ( but do not use ) the class to make phpbb happy :)
          define(IN_PHPBB,true);
          if(file_exists(ABSPATH.'/'.PHPBBPATH.'includes/captcha/captcha_factory.php')){ //needed, file doesn't exist before PHPBB 3.0.6
              include_once(ABSPATH.'/'.PHPBBPATH.'includes/captcha/captcha_factory.php');
          }
          // FIX end, RamonFincken.com WebsiteFreelancers.nl
          
        wpbb_phpBB3::getIdentity();
        $result = wpbb_phpBB3::login(strtolower($userdata->user_login),$password);
    }
	
	if($result['response'] == 1){
		//echo 1;
		return $userdata;
	}

	return 0;
}

// LOGOUT
add_action('wp_logout','wpbb_logout');
function wpbb_logout(){
	if(!defined('FROM_WP')) define('FROM_WP',TRUE);

    if(file_exists(ABSPATH.'/'.PHPBBPATH.'config.php')){ // check to see if phpBB exists
        wpbb_phpBB3::getIdentity();
        wpbb_phpBB3::logout();
    }

	return false;
}

//PASSWORD CHANGES (when a user changes his password in wordpress, it applies to phpbb)
add_filter('check_passwords', 'wpbb_change_password', 10, 3);
function wpbb_change_password($username, $pass1, $pass2){
    if(!empty($pass1) && !empty($pass2) && $pass1 == $pass2){
        wpbb_phpBB3::getIdentity();
        if(wpbb_phpBB3::getUserByName($username)){
            wpbb_phpBB3::changePassword($username,$pass1);
        }
    }    
    return true;
}

add_action('init', 'wpbb_admin_warnings');
function wpbb_admin_warnings() {
	if ( wpbb_run_test(false) ) {
		function wpbb_warning() {
			echo "
			<div id='phpbb-warning' class='updated fade'>
                        <p><strong>".__('PHP Single Sign On is almost ready.')."</strong>
                            ".sprintf(__('You have to <a href="%s">Follow the instructions</a> for it to work.'),
                             get_option('siteurl') . '/wp-admin/admin.php?page=phpbb-single-sign-on/options.php')."</p></div>
			";
		}
		add_action('admin_notices', 'wpbb_warning');
		return;
	}
}

/*
add_action('register_post', 'op_wp_userExists',10,3);
//???
function op_wp_userExists($username,$email,&$errors){
	if(op_userExists($username,'wp')){ // wordpress calls central op_userExists method
		$errors->add('username_exists', __('<strong>ERROR</strong>: This username is already registered, please choose another one.'));
	}
}

//???
function op_userExists($user, $frommodule='mw'){
	$modules = array(
		'wp'		=>	array('class'=>'op_WordPress', 'method'=>'getIdByName'),
        'phpbb'     =>  array('class'=>'op_phpBB3', 'method'=>'getUserByName')
	);


	$modules = array_diff_key($modules,array($frommodule=>TRUE));

	foreach($modules as $name => $module){
		$return = call_user_func(array($module['class'],$module['method']),$user);
		if($return) break;
	}

	return $return ? TRUE : FALSE;
}

//???
function op_updatePassword($username,$password,$frommodule='mw'){

	$modules = array();
	$modules['phpbb'] = array('class'=>'op_phpBB3', 'method'=>'changePassword');


	$modules = array_diff_key($modules,array($frommodule=>TRUE));

	foreach($modules as $name => $module){
		$return = call_user_func_array(array($module['class'],$module['method']),array('username'=>$username,'password'=>$password));
		if($return) break;
	}
}

//???
function op_updateEmail($username,$email,$frommodule='mw'){

	$modules = array();
	$modules['phpbb'] = array('class'=>'op_phpBB3', 'method'=>'changeEmail');


	$modules = array_diff_key($modules,array($frommodule=>TRUE));

	foreach($modules as $name => $module){
		$return = call_user_func_array(array($module['class'],$module['method']),array('username'=>$username,'email'=>$email));
		if($return) break;
	}
}

*/
