<?php

//wpbb_get_functions_conflict(); //TEST

$options_page = get_option('siteurl') . '/wp-admin/admin.php?page=phpbb-single-sign-on/options.php';

//POST : Check if there are new options set
if ($_POST['stage'] == 'process') {
    //Processing the Wordpress Part
    //--------------------------------------------------------------------------
    $new_options = array();

    foreach($connect_phpbb_options as $key => $option){
        $new_options[$key] = $_POST[strtolower($key)];
    }

    update_option('connect_phpbb_options', $new_options);
    $connect_phpbb_options = $new_options;


    //Processing the phpbb part
    //--------------------------------------------------------------------------
    $phpbb_db_prefix = wpbb_get_phpbb_prefix();
    if($phpbb_db_prefix != ''){
        $config_table = $phpbb_db_prefix.'config';

        if(isset($_POST['auth_method']) && $_POST['auth_method'] != ''){
            $query = "UPDATE `".$config_table."` SET `config_value` = '".$_POST['auth_method']."' WHERE `config_name` = 'auth_method' ;";
            $wpdb->query($query);
        }
    }

}


//POST : Install the plugin
if($_POST['stage'] == 'install'){
    //if the auth folder is writable
    if(is_writable($config_files['auth_wpbb']['folder'])){
            //the file is already installed
            if(!file_exists($config_files['auth_wpbb']['destin'])){
                    copy($config_files['auth_wpbb']['source'],$config_files['auth_wpbb']['destin']);
            } else {
                    unlink($config_files['auth_wpbb']['destin']);
                    copy($config_files['auth_wpbb']['source'],$config_files['auth_wpbb']['destin']);
            }
    //if the file isn't writable
    } else {
            $error = true;
    }
	
    if(is_writable($config_files['common']['folder'])){
            //is original file ?
            if(wpbb_get_file_version($config_files['common']['destin']) == 'Original') {
                    //is original file there ?
                    if(file_exists($config_files['common.orig']['destin'])){
                            unlink($config_files['common.orig']['destin']);
                    }
                    //put the original file there
                    copy($config_files['common']['destin'],$config_files['common.orig']['destin']);
            }

            //in all cases, install the file
            //is the file there ?
            if(file_exists($config_files['common']['destin'])){
                    unlink($config_files['common']['destin']);
            }
            copy($config_files['common']['source'],$config_files['common']['destin']);

    } else {
        $error = true;
            
    }
	
}

?>
<div class="wrap">
  <h2><?php _e('PHP BB Options', 'PHPBB') ?></h2>
  <form name="form1" method="post" action="<?php echo $options_page ?>&amp;updated=true">
	<input type="hidden" name="stage" value="process" />
    <table width="100%" cellspacing="2" cellpadding="5" class="form-table">
        <tr>
            <th scope="row" colspan="2"><strong>Wordpress Part</strong></th>
        </tr>
	<tr valign="baseline">
	    <th scope="row"><?php _e('Path', 'phpbb') ?></th>
	    <td>
	        <input type="text" value="<?php echo $connect_phpbb_options['path'] ?>" name="path" />
	        <div><small><?php _e('Path to the forum from the root of Wordpress', 'phpbb') ?></small></div>
	    </td>
	</tr>

        <!-- show only when path found -->
        <tr>
            <th scope="row" colspan="2"><strong>PHPBB Part</strong></th>
        </tr>
        <!--<tr valign="baseline">
	    <th scope="row"><?php _e('Path', 'phpbb') ?></th>
	    <td>
	        <input type="text" value="<?php echo $connect_phpbb_options['path'] ?>" name="path" />
	        <div><small><?php _e('Path to Wordpress from the root of the forum', 'phpbb') ?></small></div>
	    </td>
	</tr>-->
        <tr valign="baseline">
	    <th scope="row"><?php _e('Second Path', 'phpbb') ?></th>
	    <td>
                <select name="auth_method">
                    <?php echo wpbb_select_auth_method(wpbb_get_current_auth_method()); ?>
                </select>
	        <div><small><?php _e('Auth method to use, you have to use "wpbb" to make this plugin work', 'phpbb') ?></small></div>
	    </td>
	</tr>


	</table>
    <p class="submit">
      <input type="submit" name="Submit" value="<?php _e('Save Changes', 'phpbb') ?>" />
    </p>
  </form>
  <!-- Install files part -->
  <form name="form2" method="post" action="<?php echo $options_page ?>">
    <input type="hidden" name="stage" value="install" />
    <p class="submit">
		<input type="submit" name="Submit" value="<?php _e('Install Files in PHP BB', 'phpbb') ?>" /> 
    </p>
  </form>

    <?php $error = wpbb_run_test(); ?>

	<?php if($error == true) { ?>
            <p>The phpBB Plugin is not activated now.</p>

            <p>If the check didn't work correctly, you can see on the following instructions on how to manually correct the problems.</p>
            <p>Notice : if the first test isn't correct, the following won't work, so please do it in the right order.</p>

            <p><strong>path_var</strong></p>
            <p>This is the first thing you have to set, it is the relative path to your PHPBB installation.<br />
                If the wordpress is at the root of your web folder (/www/) and your forum in the wordpress folder (www/forum/).<br />
                You will have to set <strong>forum/</strong> as path. (don't forget the end slash)
            </p>

            <p><strong>auth_wpbb.php</strong></p>
            <p>This file must be copied from <strong><?php echo $config_files['auth_wpbb']['source']; ?></strong> to <strong><?php echo $config_files['auth_wpbb']['destin']; ?></strong></p>

            <p><strong>common.php</strong></p>
            <?php if(wpbb_get_file_version($config_files['common']['destin']) == 'Original'){ ?>
            <p>It seems that this file is the original common.php file.<br />
            you will have to rename this file from <strong>common.php</strong> to <strong>common.orig.php</strong><br />
            the file is in the folder <strong><?php echo $config_files['common']['folder'] ?></strong></p>
            <?php } ?>
            <p>This file must be copied from <strong><?php echo $config_files['common']['source']; ?></strong> to <strong><?php echo $config_files['common']['destin']; ?></strong></p>

            <p><strong>common.orig.php</strong></p>
            <p>You already did this on the previous step, this file doesn't exist by default, it's the original common.php file, because this script needs another one in place to load some libraries</p>

            <p><strong>auth_method</strong></p>
            <p>This form element only appears when the path_var is correctly set.<br />You have to set it to <strong>wpbb</strong></p>
            <p></p>
	<?php } ?>



</div>